*
* FLEXPAC CUSTOMIZATION FILE FOR VERSION 2.5 ONLY - WILL NOT WORK
* FOR VERSIONS EARLIER THAN 2.5 !
*
* This file is used by the FLEXCUST program to customize
*    colors
*    com port default
*    window sizes
*    user identification
* for the FLEXPAC program.  To change these things in FLEXPAC, you
* must do two things:
*
*   1) change this file to reflect your desired values, as explained below
*   2) issue the DOS command FLEXCUST
*
* The program file FLEXPAC.EXE is then altered.  Note that only this
* particular DOS file is altered - if you have more than one FLEXPAC.EXE
* program file on your disks, you will have to customize each one separately
* (or customize one and copy to the other disks).
*
* Of course, if you copy a customized FLEXPAC.EXE to another disk or
* subdirectory, the customized colors travel with it, since the file itself
* has been modified and customized.
*
* This process assumes that all files are in the current subdirectory, and
* have the standard supplied file names.  If you have changed the names, or
* if files are in different subdirectories, you must supply some parameters
* to FLEXCUST - the full format of the command is:
*   FLEXCUST <target> <source>
* where:
*   TARGET is the DOS file name of the FLEXPAC.EXE file - if not in
*      the current subdirectory, you may enter a fully qualified DOS
*      file name, such as C:\PACKET\FLEXPAC.EXE
*   SOURCE is the name of this file - if not in the current subdirectory,
*      you may enter a fully qualified DOS file name, such as
*      C:\PACKET\FLEXCUST.PRO
* Note: SOURCE and TARGET can be optional - the default TARGET is
*   FLEXPAC.EXE in the current subdirectory, and the default SOURCE is
*   FLEXCUST.PRO in the current subdirectory.  However, you CANNOT
*   default the TARGET name if you only want to specify SOURCE (in other
*   words, if you only enter one parameter, it is assumed to be the TARGET
*   parameter).
*
* **************** Modify The Color Information That Follows *************
*
* To modify this file to make your selections, you must obey two rules:
*    a) do not change the NUMBER or ORDER of the following statements -
*       YOU CAN ONLY CHANGE THE COLOR SPECIFIED ON EACH LINE.  If there
*       is a color you wish to leave alone, do exactly that - LEAVE IT
*       ALONE!
*    b) You may use only the following colors, and they must be entered
*       AS SHOWN, as one word each:
*           BLACK      BLUE       GREEN      CYAN          RED
*           MAGENTA    BROWN      LIGHTGRAY  DARKGRAY      LIGHTBLUE
*           LIGHTGREEN LIGHTCYAN  LIGHTRED   LIGHTMAGENTA
*           YELLOW     WHITE
* The color specification lines follow:
BLUE          - A screen background
BROWN         - B screen background
GREEN         - DX window background
LIGHTCYAN     - receive normal text
LIGHTRED      - FLEXPAC error text
YELLOW        - receive emphasized text (transmit echo, etc.)
BLACK         - status line background
WHITE         - status line foreground
RED           - key line background
YELLOW        - key line foreground
*
* ************* Modify The COM Port Number and Baud That Follow ************
*
1             - set comport number - 1 or 2 are the only valid options here
4800          - set the baud rate
*
* ************* Modify The Window Size Information That Follows *************
*
* There are four different ways in which FLEXPAC can split up the screen,
* based on whether the B stream and/or DX windows are open and visible.
* Some things do not change - the bottom line is always the function key
* definition line, the next to bottom line always the key input line, and
* the second from bottom always the Status Line.  The four configurations
* are:
*
*    Ŀ   Ŀ   Ŀ   Ŀ
*                   A Stream      A Stream      A Stream  
*                                              (3)Ĵ
*     A Stream     (1)Ĵ                  B Stream  
*                   B Stream     (2)Ĵ   (4)Ĵ
*                                 DX Window     DX Window 
*    StatusĴ   StatusĴ   StatusĴ   StatusĴ
*    InputĴ   InputĴ   InputĴ   InputĴ
*    Keys(5)   Keys(5)   Keys(5)   Keys(5)
*
* You will notice that the important separator lines have numbers in
* parenthesis inside them.  These are the line numbers that you can change
* to suit now ...
12            - (1) A stream to B stream, no DX window
17            - (2) A stream to DX window, no B stream
9             - (3) A stream to B stream, with DX window
17            - (4) B stream to DX window
25            - (5) maximum number of screen lines
*
* Specification (5) is the maximum number of lines on the screen;  note
* that this CAN be greater than 25 if your display supports that many
* lines.
*
* The values are checked by FLEXCUST to ensure that each window is at
* least 3 lines, and that the numbers are in the proper ascending order
* when necessary (i.e. (4) should be greater than (3)).
*
* ************* Modify The User Code Information That Follows *************
*
* FLEXPAC is distributed as Shareware.  Software distributed as Shareware
* is not in the public domain - the authors retain their Copyright rights.
* However, you are free to copy it from a friend, use it, and distibute it
* to others.  If you like the program and wish to support the availability
* of good, inexpensive software, please send $15 to cover distribution
* and handling to:
*      Tom Lindveit N2GQS
*      RD 1 Box 392C
*      West Hurley, NY 12491 USA
*
* If you send in your registration fee, you will receive a diskette
* containing the latest level of the program. In addition, you will
* be notified about fixes and enhancements.  Be sure to include your
* CALLSIGN and diskette size preference (360K/5.25 or * 720K/3.25).
*
* To remind you about Shareware, you will sometimes see a short "commercial"
* when running FLEXPAC.  If you register, you will receive a special number
* that you should enter below.  This number is derived from your callsign,
* and if correct, you will no longer get the commercial.  THANK YOU!
0             - Registration Number
*
* ************* Modify The Alarm Tone Information That Follows ************
*
* You can customize the alarm tone that FLEXPAC sounds when you connect to
* a station (@CONNECTALARM) or when someone attempts to TALK to you
* (@TALKMONITOR).  The alarm sound has two tones - you can specify the
* frequency of the tones, and their duration.  The frequency is in hertz,
* with Middle C as 440, and the duration is in TENTHs of seconds.
200           - first tone frequency
5             - first tone duration
600           - second tone freqeuncy
5             - second tone duration
*
* ************* Modify The WAIT Interval Information That Follows ************
*
* The next field contains the default number of seconds that an @WAIT
* command will wait for.  You can change this dynamically by using the
* @WAITTIME command.
60
