! ALL
  
 To get a complete help listing type  "HELP *" or "H *".  You may also 
 enter  "H xxx" where "xxx" is the command for which you need help. You may
 use '*' or '?' wildcard tokens. Help for the "?" command is under 'menu'.

 Commands, symbols and subjects currently detailed are:
 
  address   bye        chat       cmds       count      download   dir
  edit      f>         fileinfo   files      finger     get        heard
  help      home       info       kill       language   list       lu
  mail      menu       name       password   qth        read       readnews
  reply     routes     search     send       set        setmsg     signiture
  status    upload     topics     translate  view       ver        zip
  (#)       (@)        ($)        (-)        (~)       (.)

   For generic commands like List do a "help LIST" rather than the specific 
   command like LB or LT.

   The quotation marks (") may be used to include blanks in text fields of
   commands, like NAME and the SEARCH options of READ, KILL, EDIT, VIEW, LIST 

 ** HELP/MENU FILE Last Updated 02/21/90 **
*** EOF
! $

  ($) Enter this symbol in a LIST or READ range specification to 
  signify 'highest message number", without needing to know what it
  is. You can also access the highest messages via the 'last' modifier
  to most commands (i.e. KL, LL, RL, VL) which says 'do this action
  to the last ### messages visible to me'.
 
*** EOF
! -
  (-) Enter this symbol as part of a specification of a range of message
  numbers to be read or listed.  For example: R 123-456 would read all
  available messages in that range, while R 123 456 would read only those
  two messages. 
 
*** EOF
! @
  (@) Enter this symbol to indicate the BBS of the addressee, for proper
  forwarding of the message to its destination.  The message, no matter
  to whom addressed, will be forwarded to the "@ BBS" location.
   
*** EOF
! MENU
 <?>          - gives a simple Mailbox Command Syntax Summary
 <? *>        - gives a summary with brief one line descriptions
 <? <command> - gives the one line syntax display for that command only, if
                wildcard patter used , for all commands matching
 
     see also CMDS
 
*** EOF
! ~
    ALL (~) COMMANDS ARE ACTIVE DURING MESSAGE ENTRY EXCEPT '~E':

 Message Edit - Tilde Escape Menu
  ~Ccall@bbs - sends an additional copy to that call (in MAIL/RMAIL only)
  ~Mnnnnn - append the contents to message number nnnnn
  ~Q - cancel, quit or abort message entry
  ~P - display current contents of message entry buffer
  ~Rfffff - append contents of file named ffffff
  ~S - append contents of user's signiture file if it exists
  ~~xxxxxxxx - insert this line as is, with one tilde in the front of line
  ~? - gives this help menu list 

  ~E or ~V - local machine console only, invoke full screen editor

  *** these commands are deactivated when a BBS is connected and has sent
      a smart system ID to the PRMBS system
  
  see also MAIL SEND REPLY

*** EOF
! .
  (.) by entering a period ('.') on a line by itself, during message entry
  you will end the message. thsi is exactly the same as sending '/EX', or a
  ctrl-Z (^Z). The period followed by an ENTER is about the quickest and 
  easiest sequence to send, it becomes almost automatic once you send a 
  few messages.
  
*** EOF
! ADDRESS
  <address> <addr> this symbol in the syntax displays of the commands and
  these help files denotes a complete address for the recipient of a message
  it may be of the form:

       CALL    or    CALL@BBS

  In the first case its is simply the call of the recipient and it means 
  that this message will simply reside on that system to be picked up. That
  is to say if this is a (S)END command or MAIL command the message will stay
  here on this system. If it is an RMAIL command it will stay right there on
  the tragetted system. 

  If it is of the second format it will be sent out to whatever system is 
  specified by the "@BBS". If you do not know the H-Routing to the addressed
  system this host will try to place it in. If its an RMAIL and the H-Route
  is not found, the target system wil also try to add the information. It is
  more likely that the traget system will know the right H-route.
  
  *** NOTE *** while the SEND command will accept commands like
 
                  SP  K1XXX @ K2YYY

  with spaces surrounding the '@', the RMAIL and MAIL commands 'demand' that
  there be no spaces. The send command will accept no spaces also

                  RMAIL @KD6TH.NJ.USA W2VY KB7UV K2ADJ@KB1BD
                  MAIL K1XXX@K2YYY
                  SP K1XXX@K2YYY

  ROSERVER will do a certain amount of correction and  shorthand expansion
  the table below shows the extent to which it will process addresses.

   TO@BBS                 TO      BBS
  ----------------------  -----   -----------
  N1XXX@W1YYY.XX.AAA      N1XXX   W1YYY.XX.AAA
  N1ZZZ-1@W1RRR.TT.BBB    N1ZZZ   W1RRR.TT.BBB
  N2AAA.BB.CCC            N2AAA   N2AAA.BB.CCC
  N3KKK                   N3KKK


*** EOF
! BYE
 <B>ye - logs user off the system, disconnects, and updates the records. If
 this system is running under G8BPQ PC-Node emulation, the BYE command will
 return you to the switch Node to which the BBS is attached.
 
*** EOF
! CHAT
  <CHAT> - try to chat with the Sysop; if he is there he will break in.
  Any command or Return before the request times out will return you to 
  the normal mailbox prompt.
 
*** EOF
! CMDS
 <CMDS> - Lists all mailbox commands currently available.
 <CMDS xxxx> - lists mailbox commands matching the strng specified. Wild-
     cards '*' and '?' permitted.  "CMDS DI*" would list "DIR" and DISTRIB"
 
*** EOF
! COUNT

 This command is identical to the various LIST forms EXCEPT that it does
 not display  the list, only the total count of messages that would be listed
 if the 'C' command were replaced with the appropriate 'L' command. By typing
 CMDS C* you will see which C commands are available. Their use is exactly
 the same as its corresponding LIST command.

 A user might log in and type simply  COUNT and it would be the same typing
 LIST or L. It would not display thelist of new messages, but will tell
 the user the count of new messages. The count will be "true", that is not
 truncated by the line display limit.
 
*** EOF  
! DOWNLOAD
 <D path\fname> -  Download or read a file from system. Pathname is
                     needed for a file in a sub-directory. Slash or Backslash
                     is used as the separator.
 <D path\fname ####  - download first #### of the file.
 <D path\fname -#### - skip first #### bytes of the file then start download.
 <D path\fname #### ####> - download starting at #### and stop at #### bytes
                     of the file specified. 
    The number additions will allow you to download a part of a file to
    see if you have read it before, and the <from> to <to> numbers will
    allow you to read a file in parts.

    All of the above 'D' formats may be executed as 'DA' to download binary
    files over ASCII Text based pathes (TNCs etc). It will translate the
    file into BtoA format compatible with the KA2BQE binary to ASCII encoding
    (completely compatible with A2B/B2A rev 2.2 and 2.3)

    The 'DB' command will be active in the future for direct binary transfers
    to stations with compatible receiving programs. For now it produces an 
    information message.

 <DX path\fname - download file over telephone modem via XMODEM protocol
 <DY path\fname - .... via YMODEM protocol
 <DZ path\fname - .... via ZMODEM protocol
 
    *** since XMODEM is a receiver driven protocol you do not need to 
    specify checksum or CRC, your own system will tell PRMBS.

    see also FILES  UPLOAD  GET  DIR

*** EOF
! DIR
 <DIR [path]> - list of files in the download area of the BBS. Pathname
      may be included to list subdirectory files, or a search may be done
      on a filename pattern.
  
      <DIR>    - will do a directory search, listing file names and sizes.
      <DIR ffff.xxx> - will do a search on the filename pattern entered.
      <DIR ddddd> - will do a search of the subdirectory path specified
  
*** EOF
! EDIT
  <EDIT ###>   - brings up the header of a specific message for editing

  <Ex .......> - enters the message sweeper. Uses all the same arguments
                 and options as the LIST command. Presents the same user 
                 options as the MAIL command.

  see also  LIST  MAIL

 
*** EOF
! FILES
  The file system of PRMBS is based upon the tree-structured directory
  used in MSDOS and other systems such as Unix.  This program supports
  up- and downloads of files and directory listings of files  on  this
  system as well as from remote PRMBS hosts.  The system recognizes a
  special 'addressee' in mail created by the GET and GETDIR commands,
  which creates a request to a remote system to return a file or  a
  directory listing.
        eg.   " GETDIR AMSAT KD6TH "  will cause a message to be
            sent to KD6TH requesting a return message listing all
            files in the AMSAT subdirectory of that BBS.  The reply
            will be automatically addressed to the originator of the
            first message.
              " GET AMSAT/OSCAR10.TXT KD6TH" will cause a message to be
            sent to KD6TH requesting that the file named be sent back
            to the originator of the request.
*** EOF
! FILEINFO
  <FILEINFO>      
  <FILEINFO path> - this command will dump the contents of a file called
    FILEDIR.TXT, from the FILES directory or from a sub-directory thereof
    referenced by 'path'. This file has one line descriptions of the files
    uploaded by users.

*** EOF
! FINGER
  This file will be a 4000 byte maximum length file in which a user can
  put information about himself, where he lives, address, phone numbers,
  his station, equipment, interests, other hobbies, etc. This file will
  be displayed to anyone doing a  "lu yourcall" (or "finger yourcall")
  and will also be included in the information sent back to a remote
  request for user information on that user.

*** EOF
! GET
  The GETxxx commands are used to allow a user to quickly composed a remote
  request message to another system. Rather than have to remember the format
  of these specialized requests these commands take only the object desired
  and the target host as input and generate the proper message.

  see also GETBBS  GETDIG  GETDIR  GETFILE  GETMSG  GETQTH  GETUSR  GETVER

*** EOF
! GETBBS
 <GETBBS [call/ssid host]> - sends a message to the remote host requesting 
    any information on the BBS by that callsign. 
    (currently supported only by K4NGC)
         example: " getbbs N2DSY-3 K4NGC " 
 
*** EOF
! GETDIG
 <GETDIG [call/ssid host]> - sends a message to the remote host requesting 
    any information on the DIGI/NSWITCH by that callsign.
    (currently supported only by K4NGC)
         example: " getdig N2DSY-3 K4NGC " 
 
*** EOF
! GETDIR
 <GETDIR [dir host]> - sends a message to the remote host requesting a 
    list of files in the named directory.  A return message will be 
    generated from the remote host to the originator with a listing
    of the directory specified.  The "dir" should be a complete path
    to the directory wanted.
         example: " getdir *.* KD6TH "     or    " getdir AMSAT KD6TH "
 
*** EOF
! GETFILE
 <GETFILE [filename host]> - sends a message to a remote host (BBS) system 
    requesting transmission of the named file.  The file will be sent
    as a message to the originator at his home BBS (if listed).  The
    filename should be a complete path/filename description. 
         example: " get AMSAT/OSCAR10.TXT KD6TH "
 
*** EOF
! GETMSG
 <GETMSG [msgno,msgno,...,msgno] [host]> - send a message to a remote host
  requesting copies of specific messages. No limits are placed on the 
  number or sizes of messages, BUT, be advised many systems will restrict
  the passage of large messages, and often will not inform you that your 
  has been stalled due to size. If here is any question, make separate
  GETMSG requests grouping several small messages in one request and keeping
  larger messages in single requests. This feature allowing multiple message
  requests in a single query is new (25 Jan 89) It will not cause a problem
  in older systems, but it will not get anything but the first message re-
  quested.
  
*** EOF
! GETQTH
 <GETQTH [call,call,...call] [host]> - sends a message to a remote host 
    (BBS) supporting the Buckmaster CDROM Ham Callbook. You may request
    multiple calls separated by commands with NO spaces. Currently only
    WA4ONG in Virginia has this capacity. 
 
*** EOF
! GETUSR
 <GETUSR call> this is the same as FINGER or LU for the current system.
   with no host specified the local system is polled and the information
   is displayed immediately.
 <GETUSR call host> - will request log information on a user at another
   system. It wil also retrieve a FINGER file if one is present, or will 
   send  a "no user found' message if appropriate

   see also  FINGER  LU

*** EOF
! GETVER
 <GETVER host> - will request for the specified host information about
   that systems software and version level as well as what remote request
   functions it supports.

*** EOF
! HEARD
 <HEARD>     - gives a list of the configured ports in the system. 
 <HEARD ALL> - gives a dump of the calls heard on all active TNC ports and
               the stations logged in.
 <HEARD X>   - where X is a specific port letter - will display the list for 
               port only.
 
*** EOF
! HELP
 <H>   
 <H [command]>   
 <HELP>   
 <HELP [command]> - Gives a summary of the Help Subsystem. When a command
    is specified gives a detailed explanation of that command.
 
*** EOF
! HOME
 <HOME> - Will list user's current home BBS as carried on this BBS.
 
 <HOME [BBS Name]> - Permits entry of a preferred home BBS at which to
    receive mail.  Mail addressed to the user and received at this BBS 
    will be automatically readdressed and forwarded to the Home BBS en-
    tered by the user. (may be up to a 64 character hierarchical address)
 
*** EOF
! INFO
 <INFO>    - gives an paragraph on the hardware, software and of facilities
    of the mailbox station

 <INFO call> - gives information about the user acll requested, if it exists
    in the database

 
*** EOF
! KILL
 <K all> - kill all messages you are permitted to kill. 
  
 <K # #-# ... #-# #>  - which will kill a specific message(s) by number
    if and only if you are the recipient or author of the message. 
 
 <KM>      - to "Kill Mine", which will kill all your read messages
 
 <KT # # # ... #> - to kill NTS message(s), it will generate a return 
     'service message' to the station initiating the message indicating
     that you have 'taken' the traffic.
 *** NOTE ** for all above kill commands:
   User will be prompted message by message for a Yes/No/Quit. Use of the 
   "-x" will forego the prompt - be careful!! 

*** EOF
! LIST
   Generally lists messages in reverse order, newest to oldest. "Private" 
   messages not to or from you will not be listed. If no number is entered
   in any list command it will use as a default starting point the highest
   message read by the user. In the LIST LAST (LL) command the defaut number
   is one message.
 
 <L>ist     - list all new messages since your last log-in.
 
 <L ###>    - list messages back to and including number ###
 <L ###-### - list range of messages from ### to ###, forward or reverse
              depends on number order selected
 <LL ###>   - list the last ### messages.
              similar to the mail sweeper
 
   The special List commands are:
 
      L< [call]  - list all messages from this callsign
      L> [call]  - list all messages to   this callsign
      L@ [call]  - list all messages at   this callsign
      LB  - list all bulletin messages
      LM  - list mine command will list all messages addressed 
            to the user (same a  L> YOURCALL
      LP  - list all private messages to/from user
      LS  - list all traffic service messages
      LT  - list all traffic messages
 
  All LIST command support, after any options shown above an optional
  numerical starting point or range. Some examples ...

       LB 1234-1500  - will only list bulletin messages numbered in
                       that range shown

  LIST supports several options to further refine the search for messages
  -B - select bulletins only when other search criteria being used
  -D - will display all messages marked with a 'D'upe status 
  -H - will display all messages with a 'H'eld status
  -K - will display all messages with a 'K'illed status
  -L - 'long' list option, displays full title,message IDs, ROUTE names
  -M - 'mail' list option, modified display  of type ued by MAIL command
  -P - will help  you search out personal messages which have been read
  -R - will display all messages with a 'R'ejected status
  -S string  - will display messages with the 'string' contained in the
               TITLE field. The string match is made case insensitive.String 
               may be in quotes to allow 'white space'. For example;

     L -S "RATS Meeting" 1234-4567

  -X ### -will look for 'expired' messages, that is messages more than the
   number of days specified in age, relative to today.

  -Z only of use in the 'K'ill command it will kill the  messages specified in 
     a range without asking message by message (this has been nick-named the
     'RAMBO' option - use with care.


   EXAMPLES/APPLICATIONS:

   LL -L 14  - list the last 14 messages in 'long format'


  The '-L' , '-S' and either the ('-H','-K', 'R', not all together for obvious
  reasons) in various combinations with each other. For example

        LIST -H -S RATS 2345  - will list all Held messages with RATS some-
                                where in the title or address starting at
                                message 2345 thru the current highest message.

        L< -S wreck W3IWI 1   - will list all message from W3IWI on the sub-
                                ject of the train wreck.
 
  A simple point to keep in mind would be that anytime no starting number or
  range of numbers is not specified, the list will begin with the first mes-
  sage after the highest read message of the user.

  see also SEARCH  READ  EDIT  COUNT  KILL  VIEW  
 
*** EOF
! LANGUAGE
  <LANGUAGE>
  <LANGUAGE X>
  <LANGUAGE ""> displays and/or sets the possible alternate language
    files for each user. The MESSAGES file defaults to the main copy
    but user may examine the list by typing the simple command with
    no argument and select an alternate language file (if the sysop has
    offered one) by typing the command plus the proper letter. It will 
    then be stored in his user profile and each tie he logs in that
    file will be used.

*** EOF
! LU
 <LU> - displays all users of system, name, homebbs, last logged, times on
 
 <LU call> - displays to user the same info about one user
 
*** EOF
! MAIL
 <MAIL [addr1 addr2.... addrn]> - sends the message to be entered to all
   the listed addresses. 'Addresses' imply the form either CALL or CALL@BBS.
   NO SPACES may be in this form. The "To: " line in the internal header 
   will contain the ALL of the recipients of the messages so each recipient 
   knows who the other are.. All recipients are notified of the list of 
   addressees.
 
   Messages addressed to hams at other systems must have the proper @BBS
   specififed. However, if the other ham has his own BBS, you may address
   it with the proper routing in the following manner;

   MAIL K2ADJ.NJ.USA.NA will be translated to   K2ADJ@K2ADJ.NJ.USA.NA

   however;

   MAIL  K2ADJ will ** NOT ** be translated to   K2ADJ@K2ADJ    !!!

 <MAIL> - displays all messages addressed to the user. An asterisk (*)
   next to the message number indicates an unread message. The messages
   are then redisplayed one by one offering a choice to the user to
  
        k,q,r,s,u,v,?, [cr] :
 
      k - kill the message, if its type T it will ask if you want a service
          message generated
      q - quit the mail sub-system
      r - read the message without displaying mail forwarding headers
      s - send a reply to the sender of that message
      u - unread the message, return it to UNREAD status (N)
      v - view the entire message with mail headers
      ? - mini menu of the commands
      [cr] - will skip that message and move to the next one (same as ENTER])
 

  see also  MAIL  SEND  ~  ADDRESS

*** EOF
! NAME
 <NAME> - will list the user's name as carried on the BBS.
 
 <NAME name> - allow use to enter a one word name which will be translated
  to all upper case

 <NAME "Firstname Initial Lastname"> - by using quotation marks the user
  my his full name or name and initials in mixed case. The quotes will be
  removed by the system and the first 20 characters (spaces and periods 
  count) will be entered into the database.
  
     Examples:  name john    - the name JOHN in caps will be entered

                name "John H. Jones" - whole name entered in upper and
                                       lower case as on command line
 
*** EOF
! PASSWORD
 <PASSWORD> queries for the users recorded password
 <PASSWORD newpassword> enters new password

  This command will only work from the console or a serial or a modem port
  It will NOT WORK from a TNC port! (for reasons that should be obvious!)
  Passwords may not contain any spaces. 

*** EOF
! QTH
 <QTH> - will list the user's home QTH as carried on the BBS.
 
 <QTH "City, ST" by using quotation marks the user my his full home QTH.
    The quotes will be removed by the system and the first 20 characters
    (spaces and periods count) will be entered into the database.
  
     Examples: QTH "Underhill Ctr., VT" - whole QTH entered in upper and
                                          lower case as on command line
 
*** EOF
! READ
 <MAIL> - To read your mail, the most efficient manner is to type the 
 command MAIL. See HELP MAIL for the details. The MAIL sub-system will 
 allow you to read, respond, and delete your mail with simple single
 letter commands, not requiring you to remember message numbers.
 
 <R all>
 <R ## ##-## ##-## ## ... ##> - read multiple message(s) and/or ranges
 of messages by number(s). 
 
 <Rx .....> - you may read messages using the criteria, options and con-
    siderations that the LIST command offers, using serach, TO, FROM, @, 
    by type etc.

    see also HELP LIST 

*** EOF
! READNEWS

  <RN>
  <READNEWS SUBJ1 SUBJ2 ...... SUBJ9>
  <READNEWS -S xxxxx SUBJ1 SUBJ2 ...... SUBJ9>
  <READNEWS -#1200 SUBJ1 SUBJ2 ...... SUBJ9>

  This will allow the user to read bulletins in the same fashion as he 
  uses the 'MAIL' subsystem. It will allow him to specify bulletins by the
  TO address field. It will then list all bulletins that have that TO field
  match (wildcards permitted) SUBJ1 and the present them one by one for read
  and/or reply. After all bulletins matching that have been processed or the
  user 'Q'uits out that cycle, it will process SUBJ2 in the same fashion
  and so on till all topics requested have been processed.

  The process will begin with the user's 'high message read', unless the user
  uses the '-#' option to specify an alternate start number.

  The process basically depnd on the orginators of the bulletins using the
  TO field for menaingful topic names like 4SALE, HELP, HEATH, ATARI, AMSAT,
  etc.

  see also TOPICS


*** EOF
! REPLY
 <REPLY #####> - reply to message number #####, take the origin of message
    and makes it destination of the reply. The title of the original message
    get a "Re: " prefixed to it and it drops you immediately into the mes-
    sage text input. The headers of the incoming message are parsed and deter-
    mine the return BBS address. Message text entry is the same as any send
    command. The (S)end reply option of the MAIL subsystem is the exact same
    function. This command might more often be used to comment upon a bul-
    letin or general comment.
  
        see also  HELP MAIL
                  HELP ~
                  HELP SEND
 
*** EOF
! RMAIL
 <RMAIL @destbbs addr addr addr addr .... addr> - this is a 'remote' mail
    function. Sending a message in this fashion is the same as using the
    MAIL command except that you specify a destination bbs to which a single
    copy of a message is sent. At that BBS the message is 'exploded' into
    one copy for each addressee. The 'addresses' here follow the same format
    as the MAIL command, that is  CALL or CALL@BBS. So far this feature is
    unique to PRMBS/ROSE systems. Please be sure of the type of server being
    run at your desired target system. 

    Messages addressed to hams at other systems must have the proper @BBS
    specififed. However, if the other ham has his own BBS, you may address
    it with the proper routing in the following manner;

    RMAIL @W1XXX K2ADJ.NJ.USA will be translated to K2ADJ@K2ADJ.NJ.USA

    however;

    RMAIL @W1XXX K2ADJ will ** NOT ** be translated to  K2ADJ@K2ADJ    !!!



        see also  MAIL  SEND  ~  ADDRESS
*** EOF
! RN
  see READNEWS
*** EOF
! ROUTES

  When sending a bulletin to be read by many, selection of the routes helps
  make the entire network more efficient by limiting the distribution of
  the bulletin to whats necessary. The following levels of routing should
  be considered:

         NVT    - for northern vermont distribution (LOCAL)
         VTLAN  - statewide distribution            (STATE)
         NEBBS  - New England/NNY distribution      (Sub-REGION)
         NEUSA  - NorthEastern USA                  (REGION)
         ALLUSA - country wide distribution         (COUNTRY)
         ALLBBS - worldwide distribution            (WORLD)

  Please consider the nature of your topic and the audience you desire.
  There is no reason for a tower for sale that can only be manually delivered
  to go out on ALLUSA, on th eother hand some trivial items that may only
  be of interest to a few people may need ALLUSA in order to reach as far
  as possible to find these people.

  see also TOPICS SEND
  
! SEND

 <S xxxx @ yyy> - send message type '?' to station 'xxxx', at optional
    BBS 'yyy'.  BBS will prompt for title and ask you to enter text.
    End text entry with a ctrl-Z or /EX.
 
           "@ yyy" is an optional BBS address
 
    a certain amount of editing and on-line help is available using the
    tilde (~) character.
 
    Messages entered TO a valid amateur or other service callsign format will
    be sent as type 'P" - private messages all other will be sent as type 'B'
    bulletin messages except for type 'T' traffic (see below)
 

    Messages addressed to hams at other systems must have the proper @BBS
    specified. 

    see also TYPE  ~  @  ADDRESS 
 


 <ST xxxx @ yyy > - send NTS traffic type message, the T type qualifies it 
    special handling and viewing on system, plus increased accountability.

*** EOF
! SEARCH

  <SEARCH>
  PRMBS/ROSERVER permits the user to search the message header information
  for certain strings or phrases. The fields that will be compared is the
  TITLE (subject) fields. The comparison will be case insensitive (upper or
  lower is acceptable).

  The search is implemented as an option to the L(ist), E(dit), F(ile), 
  K(ill), A(rchive), R(ead), and V(iew) commands. It is done as follows.
  Say you wish to list all messages containing the phrase "RATS MEETING",
  you would type:
 
            L -S "RATS MEETING" 1

  If you did not wish to searxch the whole database, you could substitute
  for the "1", a higher number from which to start the search, or a range
  of numbers, or no number at all, in which case it will start listing
  after the highest message that you read as of your last log on.

  Maybe you have entered a bunch of messages on various subjects, but
  want to clear out all the old messages dealing with a Hamfest you 
  managed, you might type :

            K< -S "ANYTOWN HAMFEST"  KX1ME

  and all the message that you entered (you are KX1ME) with that string
  in the title somewhere will be displayed.
  
  A message that you are looking for may have been killed, but not yet
  removed from the system, you know it was dealing with a Kenwood rig for
  sale, you might type:

      L -K -S "Kenwood 721"     or        L -KS "Kenwood 721"

  *** NOTE *** the '-S' option can be stacked with others as seen above
  it can be a a separate option argument or run with others, BUT, it the
  search string itself must follow the '-s' specification separated by
  a space. Quotes may be used to include spaces as part of the search.

  see also  LIST  READ  KILL  EDIT  VIEW
*** EOF
! SET
  <SET TRANSLATE>
  <SET FINGER>
  <SET SIGNITURE>
  allows user to create or update a personal translate, signiture, or 
  finger file. This is a standard upload procedure and a failure, via
  DISConnect or entry of "/ABORT" will not replace an existing file.

  see also TRANSLATE SIGNITURE FINGER

*** EOF
! SETMSG
  <SETMSG>
  <SETMSG TOP>
  <SETMSG ###>
  this command  with no argument will display the highest message the 
  user has read on the system as of his last logon. Adding the arguement 
  TOP or a specific number will reset the number to the current highest 
  message read or whatever number is specified.

*** EOF
! SIGNITURE
  this is a small file with a standard 'signiture the user may wish to append
  to his messages on some regular basis. below is a sample (remember this is
  to be kept short - it will be nailed if it exceeds 2000 bytes)
 
  Example:
 
  +---------------------------------+--------------------+
  | 73 de tommy smith               | have you hugged    |
  | wx1xxx@wy1yyy.me.usa            | your lizard today? |
  | WillyWonkaville, ME, USA 99999  |                    |
  +---------------------------------+--------------------+

*** EOF

! STATUS
  <STATUS> - will display specific information about the system, call, QTH,
  SYSOP name, forwarding times, local routing, current date/time, current
  mumber of users and messages.

*** EOF
! TOPICS

  Below plese find a standardized list of topics to use as TO field addres-
  sees for flooded bulletins. Please try to use them where possible to make
  it easier for other users to find information they need or for you to get
  the responses to your bulletins. Alos please see the help topic ROUTES
  for information on selecting the distribution of you bulletin.


   TO:                 Covers:
  ALL     After your read everything else and it doesn't fit
          use this!         

  4SALE   Items for sale or Trade
  WANTED  Things  (material) wanted.
  HELP    ALL requests for information, help, questions, etc...
  MODS    Requests for and published Modifications for gear.
  CLASS   Ham (or other) Class Announcements
  EXAMS   Ham (or other) Examination Bullitens, dates, info, etc..
  CLUB    Club events, meetings, announcements (Ham or other)
  HAMFST  Hamfest or Flea Markets Announcements.
  MAP     Maps and Keys to Maps.
  NETWRK  Announcements about the Packet Network.
  LIST    ALL Lists (PBBS's, frequencies, repeaters,etc)
  SOFT    Any software related msgs
  BEACON  Beacon lists
  LLBBS   Msgs related to land-line BBSs.

  DX      DX reports (ARRL or other)
  SAT     All satellite related material (ARRL or other)
  PROP    Propagation reports (ARRL or other)
  QST     ALL ARRL/CRRL etc.. Bullitens not covered above.
  SPACE   general space related materials
  AMSAT   AMSAT specific space related materials

  COMPTR       C64   
  IBM          C128  
  MJF          AMIGA 
  AEA          PC    
  KANTRN       CPM
  PACCOM       UNIX
  COMDOR       VIC20
  ICOM         OSBORN
  YAESU
  KENWOD
  ALINCO
  TANDY  
  RADSHK
  ATARI

  This list grew from the efforts of KA1NNN and later added to by
  WA1IIE.

  see also ROUTES


*** EOF
! TRANSLATE
  The personal translation file is used to make things easier for the user.
  he may enter any number of shorthand notations into the file so he does 
  not have to remember long addressing. For example;

  DAD N1XXX@N6ZZZ.CA.USA
  JOE WB2MIC@WB2MIC.VT.USA
  WILLY WZ3YYY@WX6HHH.UT.USA
  SIGGY 4X4ZZ@4X1YYY.ISR.AS

  The file may be up to 4000 bytes in length. fer being passed thru this 
  transation file, the TO/AT addressing is then subjected to, and if you
  wish to look at it in this way, overidden by, the main system translation
  file.

*** EOF
! TYPE
  Message Types are either P - private, B - bulletin, S - traffic service
  message, T - traffic. The 'private' is a misnomer. It really provides a 
  mechanism for not displaying messages that are of no consequence to the 
  user. The system will take an BPST as forcibly setting the type. No type
  or an invalid type will set the message to SP or SB set according to 
  whether or not the addressee  parses as a valid ham/mars/cap/etc call-
  sign. RMAIL messages and REQxxx prior to expansion on target systems 
  will be 'P' messages.

*** EOF
! UPLOAD
 <U [path/filename]> - upload a file to the name given (path optional).
                        For example: U maps/eastnet.011
                        Reject will occur if filename already exists.

 <UX  path\fname - upload file over telephone modem via XMODEM protocol
 <UXC path\fname - .... via XMODEM CRC protocol
 <UY  path\fname - .... via YMODEM protocol
 <UZ  path\fname - .... via ZMODEM protocol
 
  *** since XMODEM is a reciever driven protocol you will need to explicitly
  tell the program to recieve in CRC or checksum mode (most current terminal
  programs support XMODEM CRC.
 
  You will be asked to enter a one line description of the file which
  will be sent as a message to the SYSOP and appended to a file in that
  directory called FILEDIR.TXT. This file can be accessed by the FILEINFO
  command to see whats in the files on the system.
 
*** EOF
! VIEW
 VIEW a message is identical to the READ command except that it displays
 the entire message including all forwarding headers.
   see also   HELP READ
 
*** EOF
! VERSION
 <VER> - version will display the version of the MailBox program being
        run and disk space available in kilobytes.
 
*** EOF
! ZIP
 <ZIP> - will list the user's home postal code on the BBS.
 
 <ZIP name> - allow use to enter a single string, no white space string
  representing his home postal routing code. It will be translated to all
  upper case
 
             Example:   zip 12345
 
*** EOF
